// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from camera_aravis2_msgs:msg/CameraDiagnostics.idl
// generated code does not contain a copyright notice
#include "camera_aravis2_msgs/msg/detail/camera_diagnostics__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `data`
#include "diagnostic_msgs/msg/detail/key_value__functions.h"

bool
camera_aravis2_msgs__msg__CameraDiagnostics__init(camera_aravis2_msgs__msg__CameraDiagnostics * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    camera_aravis2_msgs__msg__CameraDiagnostics__fini(msg);
    return false;
  }
  // data
  if (!diagnostic_msgs__msg__KeyValue__Sequence__init(&msg->data, 0)) {
    camera_aravis2_msgs__msg__CameraDiagnostics__fini(msg);
    return false;
  }
  return true;
}

void
camera_aravis2_msgs__msg__CameraDiagnostics__fini(camera_aravis2_msgs__msg__CameraDiagnostics * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // data
  diagnostic_msgs__msg__KeyValue__Sequence__fini(&msg->data);
}

bool
camera_aravis2_msgs__msg__CameraDiagnostics__are_equal(const camera_aravis2_msgs__msg__CameraDiagnostics * lhs, const camera_aravis2_msgs__msg__CameraDiagnostics * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // data
  if (!diagnostic_msgs__msg__KeyValue__Sequence__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
camera_aravis2_msgs__msg__CameraDiagnostics__copy(
  const camera_aravis2_msgs__msg__CameraDiagnostics * input,
  camera_aravis2_msgs__msg__CameraDiagnostics * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // data
  if (!diagnostic_msgs__msg__KeyValue__Sequence__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

camera_aravis2_msgs__msg__CameraDiagnostics *
camera_aravis2_msgs__msg__CameraDiagnostics__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  camera_aravis2_msgs__msg__CameraDiagnostics * msg = (camera_aravis2_msgs__msg__CameraDiagnostics *)allocator.allocate(sizeof(camera_aravis2_msgs__msg__CameraDiagnostics), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(camera_aravis2_msgs__msg__CameraDiagnostics));
  bool success = camera_aravis2_msgs__msg__CameraDiagnostics__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
camera_aravis2_msgs__msg__CameraDiagnostics__destroy(camera_aravis2_msgs__msg__CameraDiagnostics * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    camera_aravis2_msgs__msg__CameraDiagnostics__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
camera_aravis2_msgs__msg__CameraDiagnostics__Sequence__init(camera_aravis2_msgs__msg__CameraDiagnostics__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  camera_aravis2_msgs__msg__CameraDiagnostics * data = NULL;

  if (size) {
    data = (camera_aravis2_msgs__msg__CameraDiagnostics *)allocator.zero_allocate(size, sizeof(camera_aravis2_msgs__msg__CameraDiagnostics), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = camera_aravis2_msgs__msg__CameraDiagnostics__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        camera_aravis2_msgs__msg__CameraDiagnostics__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
camera_aravis2_msgs__msg__CameraDiagnostics__Sequence__fini(camera_aravis2_msgs__msg__CameraDiagnostics__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      camera_aravis2_msgs__msg__CameraDiagnostics__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

camera_aravis2_msgs__msg__CameraDiagnostics__Sequence *
camera_aravis2_msgs__msg__CameraDiagnostics__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  camera_aravis2_msgs__msg__CameraDiagnostics__Sequence * array = (camera_aravis2_msgs__msg__CameraDiagnostics__Sequence *)allocator.allocate(sizeof(camera_aravis2_msgs__msg__CameraDiagnostics__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = camera_aravis2_msgs__msg__CameraDiagnostics__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
camera_aravis2_msgs__msg__CameraDiagnostics__Sequence__destroy(camera_aravis2_msgs__msg__CameraDiagnostics__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    camera_aravis2_msgs__msg__CameraDiagnostics__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
camera_aravis2_msgs__msg__CameraDiagnostics__Sequence__are_equal(const camera_aravis2_msgs__msg__CameraDiagnostics__Sequence * lhs, const camera_aravis2_msgs__msg__CameraDiagnostics__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!camera_aravis2_msgs__msg__CameraDiagnostics__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
camera_aravis2_msgs__msg__CameraDiagnostics__Sequence__copy(
  const camera_aravis2_msgs__msg__CameraDiagnostics__Sequence * input,
  camera_aravis2_msgs__msg__CameraDiagnostics__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(camera_aravis2_msgs__msg__CameraDiagnostics);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    camera_aravis2_msgs__msg__CameraDiagnostics * data =
      (camera_aravis2_msgs__msg__CameraDiagnostics *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!camera_aravis2_msgs__msg__CameraDiagnostics__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          camera_aravis2_msgs__msg__CameraDiagnostics__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!camera_aravis2_msgs__msg__CameraDiagnostics__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
