// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from camera_aravis2_msgs:msg/CameraDiagnostics.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "camera_aravis2_msgs/msg/camera_diagnostics.hpp"


#ifndef CAMERA_ARAVIS2_MSGS__MSG__DETAIL__CAMERA_DIAGNOSTICS__TRAITS_HPP_
#define CAMERA_ARAVIS2_MSGS__MSG__DETAIL__CAMERA_DIAGNOSTICS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "camera_aravis2_msgs/msg/detail/camera_diagnostics__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'data'
#include "diagnostic_msgs/msg/detail/key_value__traits.hpp"

namespace camera_aravis2_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CameraDiagnostics & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: data
  {
    if (msg.data.size() == 0) {
      out << "data: []";
    } else {
      out << "data: [";
      size_t pending_items = msg.data.size();
      for (auto item : msg.data) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraDiagnostics & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraDiagnostics & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace camera_aravis2_msgs

namespace rosidl_generator_traits
{

[[deprecated("use camera_aravis2_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const camera_aravis2_msgs::msg::CameraDiagnostics & msg,
  std::ostream & out, size_t indentation = 0)
{
  camera_aravis2_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use camera_aravis2_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const camera_aravis2_msgs::msg::CameraDiagnostics & msg)
{
  return camera_aravis2_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<camera_aravis2_msgs::msg::CameraDiagnostics>()
{
  return "camera_aravis2_msgs::msg::CameraDiagnostics";
}

template<>
inline const char * name<camera_aravis2_msgs::msg::CameraDiagnostics>()
{
  return "camera_aravis2_msgs/msg/CameraDiagnostics";
}

template<>
struct has_fixed_size<camera_aravis2_msgs::msg::CameraDiagnostics>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<camera_aravis2_msgs::msg::CameraDiagnostics>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<camera_aravis2_msgs::msg::CameraDiagnostics>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // CAMERA_ARAVIS2_MSGS__MSG__DETAIL__CAMERA_DIAGNOSTICS__TRAITS_HPP_
